;;; python-components-execute-region.el --- execute-region forms -*- lexical-binding: t; -*- 

;; Copyright (C) 2015-2016 Andreas Röhler

;; Author: Andreas Röhler <andreas.roehler@online.de>
;; Keywords: languages, convenience

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;; Commentary:

;; This file is generated by function from python-mode-utils.el - see in
;; directory devel. Edits here might not be persistent.

;;; Code:

(defun py-execute-region (beg end &optional shell filename proc file)
  "Execute region ."
  (interactive "r")
  (py--execute-base beg end shell filename proc file))

(defun py-execute-region-switch (beg end &optional shell filename proc file)
  "Execute region ."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end shell filename proc file)))

(defun py-execute-region-no-switch (beg end &optional shell filename proc file)
  "Execute region ."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end shell filename proc file)))

(defun py-execute-region-dedicated (beg end &optional shell filename proc file)
  "Execute region ."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end shell filename proc file)))

(defun py-execute-region-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region ."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end shell filename proc file)))

(defun py-execute-region-ipython (beg end &optional shell filename proc file)
  "Execute region ipython."
  (interactive "r")
  (py--execute-base beg end 'ipython filename proc file))

(defun py-execute-region-ipython-switch (beg end &optional shell filename proc file)
  "Execute region ipython."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'ipython filename proc file)))

(defun py-execute-region-ipython-no-switch (beg end &optional shell filename proc file)
  "Execute region ipython."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'ipython filename proc file)))

(defun py-execute-region-ipython-dedicated (beg end &optional shell filename proc file)
  "Execute region ipython."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'ipython filename proc file)))

(defun py-execute-region-ipython-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region ipython."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'ipython filename proc file)))

(defun py-execute-region-ipython2.7 (beg end &optional shell filename proc file)
  "Execute region ipython2.7."
  (interactive "r")
  (py--execute-base beg end 'ipython2.7 filename proc file))

(defun py-execute-region-ipython2.7-switch (beg end &optional shell filename proc file)
  "Execute region ipython2.7."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'ipython2.7 filename proc file)))

(defun py-execute-region-ipython2.7-no-switch (beg end &optional shell filename proc file)
  "Execute region ipython2.7."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'ipython2.7 filename proc file)))

(defun py-execute-region-ipython2.7-dedicated (beg end &optional shell filename proc file)
  "Execute region ipython2.7."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'ipython2.7 filename proc file)))

(defun py-execute-region-ipython2.7-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region ipython2.7."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'ipython2.7 filename proc file)))

(defun py-execute-region-ipython3 (beg end &optional shell filename proc file)
  "Execute region ipython3."
  (interactive "r")
  (py--execute-base beg end 'ipython3 filename proc file))

(defun py-execute-region-ipython3-switch (beg end &optional shell filename proc file)
  "Execute region ipython3."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'ipython3 filename proc file)))

(defun py-execute-region-ipython3-no-switch (beg end &optional shell filename proc file)
  "Execute region ipython3."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'ipython3 filename proc file)))

(defun py-execute-region-ipython3-dedicated (beg end &optional shell filename proc file)
  "Execute region ipython3."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'ipython3 filename proc file)))

(defun py-execute-region-ipython3-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region ipython3."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'ipython3 filename proc file)))

(defun py-execute-region-jython (beg end &optional shell filename proc file)
  "Execute region jython."
  (interactive "r")
  (py--execute-base beg end 'jython filename proc file))

(defun py-execute-region-jython-switch (beg end &optional shell filename proc file)
  "Execute region jython."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'jython filename proc file)))

(defun py-execute-region-jython-no-switch (beg end &optional shell filename proc file)
  "Execute region jython."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'jython filename proc file)))

(defun py-execute-region-jython-dedicated (beg end &optional shell filename proc file)
  "Execute region jython."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'jython filename proc file)))

(defun py-execute-region-jython-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region jython."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'jython filename proc file)))

(defun py-execute-region-python (beg end &optional shell filename proc file)
  "Execute region python."
  (interactive "r")
  (py--execute-base beg end 'python filename proc file))

(defun py-execute-region-python-switch (beg end &optional shell filename proc file)
  "Execute region python."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'python filename proc file)))

(defun py-execute-region-python-no-switch (beg end &optional shell filename proc file)
  "Execute region python."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'python filename proc file)))

(defun py-execute-region-python-dedicated (beg end &optional shell filename proc file)
  "Execute region python."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'python filename proc file)))

(defun py-execute-region-python-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region python."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'python filename proc file)))

(defun py-execute-region-python2 (beg end &optional shell filename proc file)
  "Execute region python2."
  (interactive "r")
  (py--execute-base beg end 'python2 filename proc file))

(defun py-execute-region-python2-switch (beg end &optional shell filename proc file)
  "Execute region python2."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'python2 filename proc file)))

(defun py-execute-region-python2-no-switch (beg end &optional shell filename proc file)
  "Execute region python2."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'python2 filename proc file)))

(defun py-execute-region-python2-dedicated (beg end &optional shell filename proc file)
  "Execute region python2."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'python2 filename proc file)))

(defun py-execute-region-python2-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region python2."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'python2 filename proc file)))

(defun py-execute-region-python3 (beg end &optional shell filename proc file)
  "Execute region python3."
  (interactive "r")
  (py--execute-base beg end 'python3 filename proc file))

(defun py-execute-region-python3-switch (beg end &optional shell filename proc file)
  "Execute region python3."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t))
    (py--execute-base beg end 'python3 filename proc file)))

(defun py-execute-region-python3-no-switch (beg end &optional shell filename proc file)
  "Execute region python3."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p nil))
    (py--execute-base beg end 'python3 filename proc file)))

(defun py-execute-region-python3-dedicated (beg end &optional shell filename proc file)
  "Execute region python3."
  (interactive "r")
  (let ((py-dedicated-process-p t))
    (py--execute-base beg end 'python3 filename proc file)))

(defun py-execute-region-python3-dedicated-switch (beg end &optional shell filename proc file)
  "Execute region python3."
  (interactive "r")
  (let ((py-switch-buffers-on-execute-p t)
        (py-split-window-on-execute t))
    (py--execute-base beg end 'python3 filename proc file)))

(provide 'python-components-execute-region)
;;; python-components-execute-region.el ends here
